/** 
 * @Version $Rev: 202 $
 * @Author M.Sekido
 * @Date  $Date: 2016-09-29 13:22:30 +0000 (Thu, 29 Sep 2016) $
 * $Id: Dumper.cpp 202 2016-09-29 13:22:30Z vlbi $ 
 */

#include "Dumper.hpp"

Dumper::Dumper(): 
proto_mdl(0){}

void* Dumper::thread_func() {
  if( proto_mdl->ProtocolState() == TransInfo::TX_READY){
    if ( Sending() <0 ){
	      Logsystem::error_logger()->Tstamp() 
		<< "E Dumper["<< Thread::StrID()
		<< "]::thread_func(): Sending() failed.\n";
	      Logsystem::error_logger()->Flush();
    }
	  cerr << " Change Output thread state Stop.\n";
	  cerr << " Tx Timer[" <<Thread::StrID() <<"] stop called.\n";//add miya
	  proto_mdl->Timer_Stop();//add miya
	  ///Thread::stop(); //add miya 2013/12/18 comment 2015/4/3
	  cerr << " Socket_Closing...\n";
	  proto_mdl->Tx_Close();
	  cerr << " Socket_Close END.\n";
  	  Thread::stop(); //add miya 2015/4/2
  }else{
    Logsystem::error_logger()->Tstamp() 
      << "E Dumper["<< Thread::StrID() 
      << "]::thread_func(): Tx protocol is not ready. "
      << "Tx_Ready() must be first.\n";
    Logsystem::error_logger()->Flush();
  }
    
    
    //   if(fp!=0){
    //     cerr << "Writing start...";
    //     Writing();  cerr << "end\n"; return 0;}
    //   else if(proto_mdl!=0){
    //     cerr << "Sending_vdif start...\n";
    //     if(Sending_vdif() <0) cerr << "failed";
    //     cerr << "end\n"; return 0;
    //   }
    //   else if(psudp!=0){
    //     cerr << "Sending_sdup start...";
    //     Sending_sudp(); cerr << "end\n"; return 0;}
  ///cerr << " Tx Timer[" <<Thread::StrID() <<"] stop called.\n"; ///miya comment
  ///proto_mdl->Timer_Stop(); ///miya comment

  Logsystem::info_logger()->Tstamp()
    << "I Dumper["<< Thread::StrID() 
    << "]::Sending Stopping InputDev_model process, "
    << "because output is not ready or dead..\n";

  //  input_mdl->Stop(); // I doubt to stop inputmodel, It can run forever? M.S.2013.06.01
  
  //    input_mdl->InitPage(); // Initialize pages for next use
  
  Logsystem::info_logger()->Tstamp() 
    << "I Dumper::Sending["<< Thread::StrID() 
    << "]Leaving Dumper::thread_func()...\n";
  Thread::StopState();
	///usleep(1000000); ///add 2013/12/17 miya 
  Logsystem::info_logger()->Flush();
  Logsystem::debug_logger()->Flush();

  Thread::IdleState();
  return ( NULL );
}

int Dumper::Writing ( const time_t s_epoch ) {

//   if(fp ==0){
//     cerr << "E Dumper::Writing():Output file is not yet opened\n";
//     return -1;
//   }
//  int ret =0;
    if ( vlbi_frame ==0 ) {
        Logsystem::error_logger()->Tstamp()
        << "E Dumper::Writing():vlbi_frame=0 \n";
        return -1;
    }

    int loop_cnt = N_LOOP_LIMIT +10;
    int ipage = input_mdl->FirstPage();
    while (Thread::Status() == RUNNING 
	   &&  ipage ==-1 && loop_cnt >0 ) { // Data is not ready yet.
      Logsystem::debug_logger()->Tstamp()
	<< "W " << loop_cnt << " Dumper[" << Thread::StrID()
	<< "]::Wrting():Waiting to get the first page, ";
      *Logsystem::debug_logger()  << input_mdl->StrPageState ( 1 ) << "\n"; 
      Logsystem::debug_logger()->Flush();
      usleep ( 1000000 );
      ipage = input_mdl->FirstPage();
      loop_cnt --;
    }

    if ( ipage < 0 ) {
        Logsystem::error_logger()->Tstamp()
	  << "E Dumper["<< Thread::StrID()  
	  << "]::Writing():failed to get the Firstpage from InputDev.\n";
	cerr << "E Dumper["<< Thread::StrID()  
	     << "]::Writing():failed to get the Firstpage from InputDev.\n";
        return -1;
    }

    time_t device_epoch = input_mdl->Epoch ( ipage );
    time_t data_epoch = ( s_epoch ==0 ) ? ( device_epoch -2 ) : s_epoch;

    uint32_t page_size = input_mdl->PageLength()*4; // (bytes)
    const uint8_t*  raw_data(0);
    //    vector <uint8_t> dumy;
    //    vector <uint8_t> &pntr = dumy;
    //    InDev_Model::IndevReturns_t ret = InDev_Model::NORMAL;

    DAS_Info inDAS = *input_mdl->Das_inf();
    const DAS_Info& outDAS = proto_mdl->pVLBI_Frame()->DAS_Inf();
    if(dasMode == IN2OUT){
      proto_mdl->Set_DasInf(inDAS);
      /** vlbi_frame->Set_DasInfo() was replaced by proto_mdl->Set_DasInfo() because
	  VLBIframeize change must cooperate with packet size determined by protocol.
	by M.S. 2015/7/3 */
      //      vlbi_frame->Set_DasInfo(inDAS);
    }else{ // Consistency check 
      if(!outDAS.IsSubset(outDAS)){
	Logsystem::error_logger()->Tstamp()
	  << "E Dumper["<< Thread::StrID()  
	  << "]::Sending(): outDAS(" << outDAS.Mode()
	  << ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
	return -1;
      }
    }
    bool Is_SingleOut = (outDAS.Speed() == inDAS.Speed());
    
    proto_mdl->Timer_Start();
    proto_mdl->Set_St1sec();

    while ( Thread::Status() == RUNNING ) {

      raw_data = input_mdl->MappingData(data_epoch);
      if(raw_data == 0){
		Logsystem::info_logger()->Tstamp() 
		  << "I Dumper["<< Thread::StrID() 
		  << "]::Writing(): Stopped due to EndPage.\n";
		StopState();
		//	proto_mdl->Timer_Stop();
		//	return -1;
		//	ret = 0;
		break;
      }

      char dumbuf[256];
      struct tm tm1;
      gmtime_r ( &data_epoch, &tm1 );
      strftime ( dumbuf,256,"%Y/%j-%H:%M:%S",&tm1 );
      Logsystem::info_logger()->Tstamp() << "Writing data ["
					 << dumbuf << "]\n";
      size_t nwrote(0);
      vlbi_frame->Set_Epoch(data_epoch);

      if(Is_SingleOut)
	nwrote = proto_mdl->TX1sec( data_epoch, raw_data, page_size );	
      else
	nwrote = proto_mdl->TX1secSub( data_epoch, raw_data, page_size, &inDAS );
      
      if ( nwrote < page_size ) {
	cerr <<"E Dumper["<< Thread::StrID() 
	     << "]::Writing(): Wrote(" << nwrote <<" / " 
	     << page_size << ") bytes" << endl;
      }

      if( input_mdl->UnMapping ( data_epoch ) == InDev_Model::GEN_ERROR){
	cerr << "*******************************************************************\n";
	cerr << "E Dumper::Writing(): InDev Catch Up to Dumer-Output due to slow output."
	     << endl;
	cerr << "*******************************************************************\n";
	Logsystem::error_logger()->Tstamp() 
	  << "E Dumper::Writing(): InDev Catch Up to Dumer-Output due to slow output.\n";
	StopState();
      }
      
      data_epoch ++;

      if ( tspan > 0 && data_epoch >= device_epoch + tspan ) {
	fprintf ( stderr,
		  "I Dumper[%s]::Writing(): Time Span(%d sec) has passed\n",
		  Thread::StrID().c_str(), tspan );
	StopState();
	//            state = ENDING;
      }
    } // While loop
	
    proto_mdl->Timer_Stop();
    return 0;

}

int Dumper::Sending( ) {
  string func_id;
  {
    char buf[256];
    sprintf(buf,"Dumper[%s]::Sending():", Thread::StrID().c_str());
    func_id = buf;
  }

  
  Logsystem::info_logger()->Tstamp()
    << "I " << func_id <<" started.\n";
  try{
    string msg;
    if ( proto_mdl == 0 ) {
      msg = "E " + func_id + "Protocol model is not set.";
      throw  msg;
    }
    if ( vlbi_frame == 0 ){
      msg = "E " + func_id + "vlbi_frame=0 ";
      throw msg;
    }
    if( (input_mdl->DevType() == InDev_Model::NET ||
	 input_mdl->DevType() == InDev_Model::MEM ||
	 input_mdl->DevType() == InDev_Model::FILE ) &&
	input_mdl->Status() != Thread::RUNNING){
      msg = "E " + func_id + "input_mdl is not running";
      throw msg;
    }
  }
  
  catch(const string msg){
    Logsystem::error_logger()->Tstamp() << msg << "\n";
    return -1;
  }
  
  int ipage = input_mdl->FirstPage();
  int loop_cnt = N_LOOP_LIMIT +10;

  do{ // Data is not ready yet.
    string pagestate = input_mdl->StrPageState ( 1 );
    Logsystem::debug_logger()->Tstamp()
      << "W " << loop_cnt << func_id << " Waiting for the first page, \n\t"
      << pagestate << "\n";
    cerr << "W " << loop_cnt << func_id << "Waiting for the first page, \n\t"
	 << pagestate << "\n";
    Logsystem::debug_logger()->Flush();
    if(ipage !=-1) break;
    usleep ( 1000000 );
    ipage = input_mdl->FirstPage();
    loop_cnt --;
  }while (Thread::Status() == RUNNING &&  ipage == -1 && loop_cnt >0 );
 // End of While loop waiting for the first page
  // ===============================================================  

  if ( ipage < 0 ) {
    Logsystem::error_logger()->Tstamp()
      << "E " << func_id << "failed to get Firstpage from InputDev.\n";
    cerr << "E " << func_id << "failed to get Firstpage from InputDev."
	 << endl;
    return -1;
  }
  if( input_mdl->DevType() == InDev_Model::MEM ){ // add 2015/10/23 miya
  	ipage = ipage % input_mdl->Npage(); } // add 2015/10/23 miya
  else {
  	ipage = (ipage + 1) % input_mdl->Npage();}  // Page Margin added by M.S. 2013.6.16 //modify 2->0->1 miya 2014/6/27
  time_t first_epoch = input_mdl->Epoch ( ipage );
  //  int secdiff_now_dat = time(0) - first_epoch;  // Time difference from now - data for keeping constant rate.
  
  if ( first_epoch <=0 ) {
    fprintf ( stderr,
	      "E %s input_mdl->Epoch(%d) = %ld\n",
	      func_id.c_str(), ipage, first_epoch );
    Logsystem::error_logger()->Tstamp()
      << func_id << "First epoch input_mdl->Epoch("<< ipage << ")= "
      << first_epoch << "\n";
    return -1;
  }else{
    Logsystem::debug_logger()->Tstamp()
	<< "I " << func_id << "First Epoch Success(" << first_epoch << "\n";
      Logsystem::debug_logger()->Flush();
  }
  
  uint32_t page_size = input_mdl->PageLength()*4;

  //time_t data_epoch = (s_epoch ==0) ? (first_epoch -2) : s_epoch;
  time_t data_epoch = first_epoch ;
  vlbi_frame->Set_Epoch0 ( data_epoch ); // Fixing Reference Epoch for VDIF
  DAS_Info inDAS = *input_mdl->Das_inf();
  const DAS_Info& outDAS = proto_mdl->pVLBI_Frame()->DAS_Inf();
  //     DAS_Info tmpdas(inDAS.Srate(),outDAS.Nch(), inDAS.Qbit()) ;
  //     proto_mdl->pVLBI_Frame()->Set_DasInfo(tmpdas);
  
  if(dasMode == IN2OUT){ // Straight output from input  
    proto_mdl->Set_DasInf(inDAS); 
    /** vlbi_frame->Set_DasInfo() was replaced by proto_mdl->Set_DasInfo() because
	VLBIframeize change must cooperate with packet size determined by protocol.
	by M.S. 2015/7/3 */
    //    vlbi_frame->Set_DasInfo(inDAS);
  }else{ // Input mode != Output mode 
    // Consistency check 
    if(!inDAS.IsSubset(outDAS)){
      Logsystem::error_logger()->Tstamp()
	<< "E " << func_id << "outDAS(" << outDAS.Mode()
	<< ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
      cerr
	<< "E " << func_id << " outDAS(" << outDAS.Mode()
	<< ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
      return -1;
    }
  }

  if ( Logsystem::Test_Logsys ( Logsystem::INFO ) ) {
    // For print information
    time_t end_epoch = tspan > 0 ? data_epoch + tspan : 0;
    Time_dat st_time ( data_epoch ), et_time ( end_epoch );
    Logsystem::info_logger()->Tstamp()
      << "I " << func_id << "Sending (" << outDAS.Mode()
      << ") from Time:"   << st_time.Print_time ( 10 ) ;
    if ( tspan >0 )
      *Logsystem::info_logger()  << " to " << et_time.Print_time ( 10 );
    *Logsystem::info_logger()  << "\n";
    Logsystem::info_logger()->Tstamp() 
      << " In-Mode=" << inDAS.Mode() << ", Out-Mode=" 
      << outDAS.Mode() << "\n";
    cerr << " In-Mode=" << inDAS.Mode() << ", Out-Mode=" 
	 << outDAS.Mode() << endl;
  }

  proto_mdl->Timer_Start();
  proto_mdl->Set_St1sec();
  
  string stname;
  vlbi_frame->Set_StnameID(input_mdl->Stname().c_str(), input_mdl->StnID().c_str());
  proto_mdl->pVLBI_Frame()->Set_StnameID(input_mdl->Stname().c_str(), 
					 input_mdl->StnID().c_str());
  cerr << "I " << func_id << " Stname(" << input_mdl->Stname() << ") and ID("
       << input_mdl->StnID() << ") is set for output frame" << endl;
  //comment 2014/11/19 miya start ------------------------------------------------------------------
  //if ( proto_mdl->TransProtocol() == TransInfo::FILE_IO && vlbi_frame->Type() == VLBI_Frame::VDIF_frm ){ 
  //  vlbi_frame->Set_Framesize ( page_size / vlbi_frame->Nframe_sec() + vlbi_frame->Headsize() ); // add 2013/12/16 miya modify Ndiv -> nframe_sec 2014/5/20 miya
  //}
  //comment 2014/11/19 miya end ------------------------------------------------------------------
  const uint8_t* raw_data(0);
  //    vector <uint8_t> dumy;
  //    vector <uint8_t> &pntr = dumy;
  //    InDev_Model::IndevReturns_t ret = InDev_Model::NORMAL;
  int nsent ( 0 );
  //    double timePerPage=0;
  while ( Thread::Status() == RUNNING && nsent >= 0 ) {
    
    Logsystem::info_logger()->Tstamp() 
      << "I " << func_id << "Mapping epoch=" 	<< data_epoch 
      << " input-Stname=" << input_mdl->Stname() << "\n";
    Logsystem::info_logger()->Flush();
    
    Logsystem::debug_logger()->Tstamp()
      << "Dumper[" << Thread::StrID() << "]::Sending():" << input_mdl->StrPageState ( 1 ) << "\n"; 
      Logsystem::debug_logger()->Flush();
	  
    ///IntvlRegulator(); // by M.S. 2013.6.16 for keeping constant interval. // miya comment
      
      raw_data = input_mdl->MappingData ( data_epoch );
    Logsystem::debug_logger()->Tstamp() << "data_epoch = " << data_epoch << "\n";
    Logsystem::debug_logger()->Flush();

    if( raw_data == 0){
      // miya comment start-------------------------------------------------------------
      ///time_t frm_epoch= input_mdl->Epoch(ipage);
      ///if( frm_epoch > data_epoch){
		///cerr << "W Expected epoch(" << data_epoch << ") < Dev-Epoch(" << ipage << ")=" 
		///     << frm_epoch << "\n";
		///Logsystem::info_logger()->Tstamp() 
		///  << "W Expected epoch(" << data_epoch << ") < Dev-Epoch(" << ipage << ")=" 
		///  << frm_epoch << "\n";
		///data_epoch ++; ipage++;
		///continue;
      ///}
      ///Logsystem::error_logger()->Tstamp()
	///<< "I " << func_id <<	 "MappingData("<< data_epoch << ") failed..\n";
      ///cerr << "I " << func_id << "MappingData(" << data_epoch << ") failed." << endl;
     // miya comment end-------------------------------------------------------------
      if( input_mdl->DevType() != InDev_Model::K5VSI ){ // add 'if' 2014/11/11 miya
	      StopState();
	      //	return -0;
	      break;
    	}
    }else{ // add 'else' 2014/11/11 miya
	//     if(Logsystem::Test_Logsys(Logsystem::INFO))  {
	//       char dumbuf[256];
	//       struct tm tm1;
	//       gmtime_r ( &data_epoch, &tm1 );
	//       strftime ( dumbuf,256,"%Y/%j-%H:%M:%S",&tm1 );
	//       Logsystem::info_logger()->Tstamp() 
	// 	<< "I " << func_id << "Sending out data [" << dumbuf << "] at "
	// 	<< proto_mdl->Tx_rate() << " Mbps (net:"
	// 	<< proto_mdl->Tx_pld_rate()  << " Mbps)\n";
	//       Logsystem::info_logger()->Flush();
	//       cerr  << "I " << func_id << "Sending out data [" 
	// 	    << dumbuf << "] at "
	// 	    << proto_mdl->Tx_rate() << " Mbps (net:"
	// 	    << proto_mdl->Tx_pld_rate()  << " Mbps)" << endl;
	//     }
	    vlbi_frame->Set_Epoch(data_epoch);
	    
	    bool Is_SingleOut = (outDAS.Speed() == inDAS.Speed());
	    // If single output, DAS-info is copied from input.
	    if(Is_SingleOut){ // Straight output from input 
	      //	nsent = proto_mdl->TX1sec( data_epoch, pntr);
	      nsent = proto_mdl->TX1sec( data_epoch, raw_data, page_size);
	    }else{   // InputMode != OutputMode
	      //	nsent = proto_mdl->TX1secSub( data_epoch, pntr, &inDAS);
	      nsent = proto_mdl->TX1secSub( data_epoch, raw_data, page_size, &inDAS);
	    }
	    if ( nsent < 0 ) {
	      Logsystem::error_logger()->Tstamp()
		<< "E " << func_id << "proto_mdl->TX1sec() failed, quitting.\n";
	      break;
	    }
	    //     fprintf(stderr, "%4d Epoch = %s :",past_sec,time_code);
	    //     fprintf(stderr,"Mode = %s (%.2lf Mbps): ",
	    // 	    vlbi_frame->DAS_Inf()->Mode().c_str(), 0.000001*(8*nsent));
	    //     fprintf(stderr,"Send rate = %.2lf [Mbps] ttl %.2lf MB\n",
	    // 	    proto_mdl->TX_rate(), proto_mdl->Sent_MBytes());
	    
	    //      input_mdl->UnMapping ( data_epoch ); // Release the address mapping
	    if( input_mdl->UnMapping ( data_epoch ) == InDev_Model::GEN_ERROR){
	      cerr << "*******************************************************************\n";
	      cerr << "E Dumper[" << func_id 
		   << "]::Sending(): InDev Catch Up to Dumer-Output due to slow output."
		   << endl;
	      cerr << "*******************************************************************\n";
	      Logsystem::error_logger()->Tstamp() 
		<< "E Dumper::Writing(): InDev Catch Up to Dumer-Output due to slow output.\n";
	      StopState();
	      continue;
	    }else{
	      Logsystem::info_logger()->Tstamp() 
		<< "I " << func_id << "UnMapping end.\n";
	    }
   		if ( proto_mdl->Ack_Check() == false ){ StopState(); }   // add miya 2015/6/23
    }// add miya 2014/11/11
  	
    data_epoch ++;
    
    Logsystem::debug_logger()->Tstamp()
      << "D " << func_id << "Current Epoch=" << data_epoch << " +span(" 
      << tspan << ")End Epoch=" <<  first_epoch + tspan << "\n"; 
    Logsystem::debug_logger()->Flush();
    
    if ( tspan > 0 && data_epoch >= first_epoch + tspan ) {
      fprintf( stderr,
	       "I %s Stopping to write: Time Span(%d sec) has passed.\n",
	       func_id.c_str(), tspan );
      StopState();
      //	state= ENDING;
    }
    ///Logsystem::warning_logger()->Tstamp() 
  } // While loop
  
  Logsystem::info_logger()->Tstamp() << "I " << func_id << " end.\n";
  //    proto_mdl->Timer_Stop();
  return 0;
}

bool Dumper::Ready(){
	
  if( proto_mdl==0){
    cerr << "E Dumper::Ready(): output protocol_model is not set." 
	 << endl;
    Logsystem::error_logger()->Tstamp()
      << "E Dumper::Ready(): output protocol_model is not set.\n";
    return false;  
  }
  if(input_mdl ==0){
    cerr << "E Dumper::Ready(): data input model is not set." << endl;
    Logsystem::error_logger()->Tstamp()
      << "E Dumper::Ready(): data input model is not set.\n";
    return false;  
  }
  if( Thread::Status() == Thread::RUNNING){
      Logsystem::error_logger()->Tstamp()  
	  << "E Dumper::Ready():Dumper is already running..\n";
      return false;
  }
  
  Logsystem::debug_logger()->Tstamp()  
    << "D Dumper::Ready():input_mdl->Ready() inprogress..";
  if(! input_mdl->Ready()){
    cerr << "E Dumper::Ready(): input_mdl contents is not ready()";
    return false;
  }
  *Logsystem::debug_logger() << "input_mdl->Ready()Finished.\n";
  Logsystem::debug_logger()->Flush();
  
  if(input_mdl->Status() != Thread::RUNNING) input_mdl->start();

  if(vlbi_frame ==0){ // For output 
    cerr << "E Dumper::Ready(): VLBI_frame is not set. " 
	 << "It must be set in Set_IO()."<< endl;
    Logsystem::error_logger()->Tstamp()
      << "E Dumper::Ready(): VLBI_frame is not set" 
      << "It must be set in Set_IO().\n";
    return false;  
  }
  
//   /** If Nchs of input-output VLBI frame are the same, DAS-info is copied
//    * from input to Output.
//    * othewise original DAS-info in the proto_mdl is used. 
//    */
//   if(vlbi_frame->DAS_Inf().Nch() == input_mdl->Das_inf()->Nch()){
//     int nch = input_mdl->Das_inf()->Nch();
//     int nbit = input_mdl->Das_inf()->Qbit();
//     uint32_t  srate = input_mdl->Das_inf()->Srate();
//     vlbi_frame->Set_Sparam(nch, nbit,srate);
//   }

  if( ! proto_mdl->Tx_Ready() ){
    Logsystem::error_logger()->Tstamp()
      << "E Dumper::Ready(): proto_mdl->Tx_Ready() failed.\n";
    return false;
  }
  

  return true;
  
}

