

#ifndef __DUMPER__
#define __DUMPER__
/** Dumper (Output) class library
 * @Version $Rev: 159 $
 * @Author M.Sekido
 * @Date  $Date: 2015-04-23 11:33:25 +0900 (木, 23  4月 2015) $
 * $Id: Dumper.hpp 159 2015-04-23 02:33:25Z vlbi $ 
 */

#include <string>

#include "VirDumper.hpp"

/** Dumper
 * Function: Output data to Net/File. When multiple dumper instances are cleated and
 * used for output data streaming, Input model could be shared, but Protocol model 
 * instances must be independents at Set_IO(), because VLBI_Proto has socket and VLBI_Frame
 * pinters in the protocol should be independent for multile output.
 * $Author: vlbi $
 * $Revision: 159 $ $Date: 2015-04-23 11:33:25 +0900 (木, 23  4月 2015) $
 * $Id: Dumper.hpp 159 2015-04-23 02:33:25Z vlbi $
 */

class Dumper: public VirDumper{
public: 
  /** Default Constructor  */
  Dumper();
  /** Default Desructor  */
  ~Dumper(); 
  void* thread_func(); ///< Thread function
  int Set_IO(VLBI_Proto *v, InDev_Model *k, const int ith=0 ); 
  int Writing(const time_t s_epoch=0); ///< Main function for writing data 
  int Sending(); ///< Main function to sending data 
  bool Ready(); ///< Check/Make ready
  VLBI_Proto* proto_mdl;  ///< Output Protocol(including header format) used
};

/** Set in Input model and Output Protocol
 *  Then Input module started.
 */

inline  int Dumper::Set_IO(VLBI_Proto *v, InDev_Model *k, const int ith){
  proto_mdl = v;
  input_mdl=k;
  vlbi_frame = v->pVLBI_Frame();
//   if(input_mdl->OpenDev() <0){
//     cerr << "Error: Failed to open K5_VSI\n"; 
//     return -1;
//   } 

//   if(input_mdl->Status() != Thread::RUNNING)
//       input_mdl->start();
  return 0;
}

/** Destructor */
inline Dumper::~Dumper(){
  if( proto_mdl != 0 ) proto_mdl = 0;
}


#endif
