/** 
 * @Version $Rev: 155 $
 * @Author M.Sekido
 * @Date  $Date: 2014-12-01 17:15:16 +0900 (朁E 01 12朁E2014) $
 * $Id: FileDumper.cpp 155 2014-12-01 08:15:16Z vlbi $ 
 */

#include "FileDumper.hpp"

FileDumper::FileDumper()
{
  for(int i=0; i<NFileout; i++) proto_mdl[i] = 0; // add 2012/12/10 miya
}

void* FileDumper::thread_func() {

  if( proto_mdl[0]->ProtocolState() == TransInfo::TX_READY){ //sending1threadȂ̂proto_mdl[0]̂܂܂ok miya

    if ( Sending() <0 ){
	      Logsystem::error_logger()->Tstamp() 
		<< "E FileDumper["<< Thread::StrID()
		<< "]::thread_func(): Sending() failed.\n";
	      Logsystem::error_logger()->Flush();
    }
	  cerr << " Change Output thread state Stop.\n";
	  cerr << " Tx Timer[" <<Thread::StrID() <<"] stop called.\n";//add miya
	  for(int ith=0; ith < NFileout; ith++){ // add 2014/12/9 miya
		proto_mdl[ith]->Timer_Stop();//add miya
	  }
	  ///Thread::stop(); //add miya 2013/12/18 comment 2015/4/3
	  cerr << " Socket_Closing...\n";
	  for(int ith=0; ith < NFileout; ith++){ // add 2014/12/9 miya
  		proto_mdl[ith]->Tx_Close();
	  }
  	  	  usleep(1000000); ///add 2015/10/28 miya 

	  cerr << " Socket_Close END.\n";
  	  Thread::stop(); //add miya 2015/4/2
  }else{
    Logsystem::error_logger()->Tstamp() 
      << "E FileDumper["<< Thread::StrID() 
      << "]::thread_func(): Tx protocol is not ready. "
      << "Tx_Ready() must be first.\n";
    Logsystem::error_logger()->Flush();
  }
    
    //   if(fp!=0){
    //     cerr << "Writing start...";
    //     Writing();  cerr << "end\n"; return 0;}
    //   else if(proto_mdl!=0){
    //     cerr << "Sending_vdif start...\n";
    //     if(Sending_vdif() <0) cerr << "failed";
    //     cerr << "end\n"; return 0;
    //   }
    //   else if(psudp!=0){
    //     cerr << "Sending_sdup start...";
    //     Sending_sudp(); cerr << "end\n"; return 0;}
  ///cerr << " Tx Timer[" <<Thread::StrID() <<"] stop called.\n"; ///miya comment
  ///proto_mdl->Timer_Stop(); ///miya comment

  Logsystem::info_logger()->Tstamp()
    << "I FileDumper["<< Thread::StrID() 
    << "]::Sending Stopping InputDev_model process, "
    << "because output is not ready or dead..\n";

  //  input_mdl->Stop(); // I doubt to stop inputmodel, It can run forever? M.S.2013.06.01
  
  //    input_mdl->InitPage(); // Initialize pages for next use
  
  Logsystem::info_logger()->Tstamp() 
    << "I FileDumper::Sending["<< Thread::StrID() 
    << "]Leaving FileDumper::thread_func()...\n";
  Thread::StopState();
	///usleep(1000000); ///add 2013/12/17 miya 
  Logsystem::info_logger()->Flush();
  Logsystem::debug_logger()->Flush();

  Thread::IdleState();
  return ( NULL );
}

int FileDumper::Writing ( const time_t s_epoch ) {

//   if(fp ==0){
//     cerr << "E FileDumper::Writing():Output file is not yet opened\n";
//     return -1;
//   }
//  int ret =0;
    if ( vlbi_frame ==0 ) {
        Logsystem::error_logger()->Tstamp()
        << "E FileDumper::Writing():vlbi_frame=0 \n";
        return -1;
    }

    int loop_cnt = N_LOOP_LIMIT +10;
    int ipage = input_mdl->FirstPage();
    while (Thread::Status() == RUNNING 
	   &&  ipage ==-1 && loop_cnt >0 ) { // Data is not ready yet.
      Logsystem::debug_logger()->Tstamp()
	<< "W " << loop_cnt << " FileDumper[" << Thread::StrID()
	<< "]::Wrting():Waiting to get the first page, ";
      *Logsystem::debug_logger()  << input_mdl->StrPageState ( 1 ) << "\n"; 
      Logsystem::debug_logger()->Flush();
      usleep ( 1000000 );
      ipage = input_mdl->FirstPage();
      loop_cnt --;
    }

    if ( ipage < 0 ) {
        Logsystem::error_logger()->Tstamp()
	  << "E FileDumper["<< Thread::StrID()  
	  << "]::Writing():failed to get the Firstpage from InputDev.\n";
	cerr << "E FileDumper["<< Thread::StrID()  
	     << "]::Writing():failed to get the Firstpage from InputDev.\n";
        return -1;
    }

    time_t device_epoch = input_mdl->Epoch ( ipage );
    time_t data_epoch = ( s_epoch ==0 ) ? ( device_epoch -2 ) : s_epoch;

    uint32_t page_size = input_mdl->PageLength()*4; // (bytes)
    const uint8_t*  raw_data(0);
    //    vector <uint8_t> dumy;
    //    vector <uint8_t> &pntr = dumy;
    //    InDev_Model::IndevReturns_t ret = InDev_Model::NORMAL;

    DAS_Info inDAS = *input_mdl->Das_inf();
    const DAS_Info& outDAS = proto_mdl[0]->pVLBI_Frame()->DAS_Inf();
    if(dasMode == IN2OUT){
      proto_mdl[0]->Set_DasInf(inDAS);
      /** vlbi_frame->Set_DasInfo() was replaced by proto_mdl->Set_DasInfo() because
	  VLBIframeize change must cooperate with packet size determined by protocol.
	by M.S. 2015/7/3 */
      //vlbi_frame->Set_DasInfo(inDAS);
    }else{ // Consistency check 
      if(!outDAS.IsSubset(outDAS)){
	Logsystem::error_logger()->Tstamp()
	  << "E FileDumper["<< Thread::StrID()  
	  << "]::Sending(): outDAS(" << outDAS.Mode()
	  << ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
	return -1;
      }
    }
    bool Is_SingleOut = (outDAS.Speed() == inDAS.Speed());
    
    proto_mdl[0]->Timer_Start();
    proto_mdl[0]->Set_St1sec();

    while ( Thread::Status() == RUNNING ) {

      raw_data = input_mdl->MappingData(data_epoch);
      if(raw_data == 0){
		Logsystem::info_logger()->Tstamp() 
		  << "I FileDumper["<< Thread::StrID() 
		  << "]::Writing(): Stopped due to EndPage.\n";
		StopState();
		//	proto_mdl->Timer_Stop();
		//	return -1;
		//	ret = 0;
		break;
      }

      char dumbuf[256];
      struct tm tm1;
      gmtime_r ( &data_epoch, &tm1 );
      strftime ( dumbuf,256,"%Y/%j-%H:%M:%S",&tm1 );
      Logsystem::info_logger()->Tstamp() << "Writing data ["
					 << dumbuf << "]\n";
      size_t nwrote(0);

      if(Is_SingleOut)
	nwrote = proto_mdl[0]->TX1sec( data_epoch, raw_data, page_size );	
      else
	nwrote = proto_mdl[0]->TX1secSub( data_epoch, raw_data, page_size, &inDAS );
      
      if ( nwrote < page_size ) {
	cerr <<"E FileDumper["<< Thread::StrID() 
	     << "]::Writing(): Wrote(" << nwrote <<" / " 
	     << page_size << ") bytes" << endl;
      }

      if( input_mdl->UnMapping ( data_epoch ) == InDev_Model::GEN_ERROR){
	cerr << "*******************************************************************\n";
	cerr << "E FileDumper::Writing(): InDev Catch Up to Dumer-Output due to slow output."
	     << endl;
	cerr << "*******************************************************************\n";
	Logsystem::error_logger()->Tstamp() 
	  << "E FileDumper::Writing(): InDev Catch Up to Dumer-Output due to slow output.\n";
	StopState();
      }
      
      data_epoch ++;

      if ( tspan > 0 && data_epoch >= device_epoch + tspan ) {
	fprintf ( stderr,
		  "I FileDumper[%s]::Writing(): Time Span(%d sec) has passed\n",
		  Thread::StrID().c_str(), tspan );
	StopState();
	//            state = ENDING;
      }
    } // While loop
	
    proto_mdl[0]->Timer_Stop();
    return 0;

}

int FileDumper::Sending( ) {
  string func_id;
  {
    char buf[256];
    sprintf(buf,"FileDumper[%s]::Sending():", Thread::StrID().c_str());
    func_id = buf;
  }

  
  Logsystem::info_logger()->Tstamp()
    << "I " << func_id <<" started.\n";
  try{
    string msg;
    if ( proto_mdl[0] == 0 ) {
      msg = "E " + func_id + "Protocol model is not set.";
      throw  msg;
    }
    if ( vlbi_frame == 0 ){
      msg = "E " + func_id + "vlbi_frame=0 ";
      throw msg;
    }
    if( (input_mdl->DevType() == InDev_Model::NET ||
	 input_mdl->DevType() == InDev_Model::MEM ||
	 input_mdl->DevType() == InDev_Model::FILE ) &&
	input_mdl->Status() != Thread::RUNNING){
      msg = "E " + func_id + "input_mdl is not running";
      throw msg;
    }
  }
  
  catch(const string msg){
    Logsystem::error_logger()->Tstamp() << msg << "\n";
    return -1;
  }
  
  int ipage = input_mdl->FirstPage();
  int loop_cnt = N_LOOP_LIMIT +10;
  //int npage = (input_mdl->Npage())-1; // add 2016/9/29 miya

  do{ // Data is not ready yet.
    string pagestate = input_mdl->StrPageState ( 1 );
    Logsystem::debug_logger()->Tstamp()
      << "W " << loop_cnt << func_id << " Waiting for the first page, \n\t"
      << pagestate << "\n";
    cerr << "W " << loop_cnt << func_id << "Waiting for the first page, \n\t"
	 << pagestate << "\n";
    Logsystem::debug_logger()->Flush();
    if(ipage !=-1) break;
    usleep ( 1000000 );
    ipage = input_mdl->FirstPage();
    loop_cnt --;
  }while (Thread::Status() == RUNNING &&  ipage == -1 && loop_cnt >0 );
 // End of While loop waiting for the first page
  // ===============================================================  

  if ( ipage < 0 ) {
    Logsystem::error_logger()->Tstamp()
      << "E " << func_id << "failed to get Firstpage from InputDev.\n";
    cerr << "E " << func_id << "failed to get Firstpage from InputDev."
	 << endl;
    return -1;
  }
  if( input_mdl->DevType() == InDev_Model::MEM ){ // add 2015/10/23 miya
  	ipage = ipage % input_mdl->Npage(); } // add 2015/10/23 miya
  else {
  	ipage = (ipage + 1) % input_mdl->Npage();}  // Page Margin added by M.S. 2013.6.16 //modify 2->0->1 miya 2014/6/27
  time_t first_epoch = input_mdl->Epoch ( ipage );
  //  int secdiff_now_dat = time(0) - first_epoch;  // Time difference from now - data for keeping constant rate.
  
  if ( first_epoch <=0 ) {
    fprintf ( stderr,
	      "E %s input_mdl->Epoch(%d) = %ld\n",
	      func_id.c_str(), ipage, first_epoch );
    Logsystem::error_logger()->Tstamp()
      << func_id << "First epoch input_mdl->Epoch("<< ipage << ")= "
      << first_epoch << "\n";
    return -1;
  }else{
    Logsystem::debug_logger()->Tstamp()
	<< "I " << func_id << "First Epoch Success(" << first_epoch << "\n";
      Logsystem::debug_logger()->Flush();
  }
  
  uint32_t page_size = input_mdl->PageLength()*4;

  //time_t data_epoch = (s_epoch ==0) ? (first_epoch -2) : s_epoch;
  time_t data_epoch = first_epoch ;
  vlbi_frame->Set_Epoch0 ( data_epoch ); // Fixing Reference Epoch for VDIF
  DAS_Info inDAS = *input_mdl->Das_inf();
  const DAS_Info& outDAS = proto_mdl[0]->pVLBI_Frame()->DAS_Inf();
  //     DAS_Info tmpdas(inDAS.Srate(),outDAS.Nch(), inDAS.Qbit()) ;
  //     proto_mdl->pVLBI_Frame()->Set_DasInfo(tmpdas);
  
  if(dasMode == IN2OUT){ // Straight output from input  
    proto_mdl[0]->Set_DasInf(inDAS); 
    /** vlbi_frame->Set_DasInfo() was replaced by proto_mdl->Set_DasInfo() because
	VLBIframeize change must cooperate with packet size determined by protocol.
	by M.S. 2015/7/3 */
    //vlbi_frame->Set_DasInfo(inDAS);
  }else{ // Input mode != Output mode 
    // Consistency check 
    if(!inDAS.IsSubset(outDAS)){
      Logsystem::error_logger()->Tstamp()
	<< "E " << func_id << "outDAS(" << outDAS.Mode()
	<< ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
      cerr
	<< "E " << func_id << " outDAS(" << outDAS.Mode()
	<< ") is not subset of inDAS(" << inDAS.Mode() << ").\n";
      return -1;
    }
  }

  if ( Logsystem::Test_Logsys ( Logsystem::INFO ) ) {
    // For print information
    time_t end_epoch = tspan > 0 ? data_epoch + tspan : 0;
    Time_dat st_time ( data_epoch ), et_time ( end_epoch );
    Logsystem::info_logger()->Tstamp()
      << "I " << func_id << "Sending (" << outDAS.Mode()
      << ") from Time:"   << st_time.Print_time ( 10 ) ;
    if ( tspan >0 )
      *Logsystem::info_logger()  << " to " << et_time.Print_time ( 10 );
    *Logsystem::info_logger()  << "\n";
    Logsystem::info_logger()->Tstamp() 
      << " In-Mode=" << inDAS.Mode() << ", Out-Mode=" 
      << outDAS.Mode() << "\n";
    cerr << " In-Mode=" << inDAS.Mode() << ", Out-Mode=" 
	 << outDAS.Mode() << endl;
  }

  //proto_mdl[0]->Timer_Start(); // comment 2014/12/9 miya
  //proto_mdl[0]->Set_St1sec(); // comment 2014/12/9 miya
  
  bool Is_SingleOut = (outDAS.Speed() == inDAS.Speed()); // add 2014/12/9 miya

  string stname;
  vlbi_frame->Set_StnameID(input_mdl->Stname().c_str(), input_mdl->StnID().c_str());
  if(Is_SingleOut){ // add 2014/12/9 miya
  	  proto_mdl[0]->Timer_Start();
  	  proto_mdl[0]->Set_St1sec();
	  proto_mdl[0]->pVLBI_Frame()->Set_StnameID(input_mdl->Stname().c_str(), 
						 input_mdl->StnID().c_str());
  }else{ for(int ith=0; ith < NFileout; ith++) { // add 2014/12/9 miya
  	  proto_mdl[ith]->Timer_Start(); // add 2014/12/9 miya
  	  proto_mdl[ith]->Set_St1sec(); // add 2014/12/9 miya
	  proto_mdl[ith]->pVLBI_Frame()->Set_StnameID(input_mdl->Stname().c_str(), 
						 input_mdl->StnID().c_str());} // add 2014/12/9 miya
  }
  cerr << "I " << func_id << " Stname(" << input_mdl->Stname() << ") and ID("
       << input_mdl->StnID() << ") is set for output frame" << endl;
  //comment 2014/11/19 miya start ------------------------------------------------------------------
  //if ( proto_mdl[0]->TransProtocol() == TransInfo::FILE_IO && vlbi_frame->Type() == VLBI_Frame::VDIF_frm ){ 
    //vlbi_frame->Set_Framesize ( page_size / vlbi_frame->Nframe_sec() + vlbi_frame->Headsize() ); // add 2013/12/16 miya modify Ndiv -> nframe_sec 2014/5/20 miya
  //}
  //comment 2014/11/19 miya end ------------------------------------------------------------------
  const uint8_t* raw_data(0);
  //    vector <uint8_t> dumy;
  //    vector <uint8_t> &pntr = dumy;
  //    InDev_Model::IndevReturns_t ret = InDev_Model::NORMAL;
  int nsent ( 0 );
  //int zero_data_epoch(0); // add 2016/9/29 miya
  //    double timePerPage=0;
  while ( Thread::Status() == RUNNING && nsent >= 0 ) {

    Logsystem::info_logger()->Tstamp() 
      << "I " << func_id << "Mapping epoch=" 	<< data_epoch 
      << " input-Stname=" << input_mdl->Stname() << "\n";
    Logsystem::info_logger()->Flush();

    Logsystem::debug_logger()->Tstamp()
      << "FileDumper[" << Thread::StrID() << "]::Sending():" << input_mdl->StrPageState ( 1 ) << "\n"; 
    Logsystem::debug_logger()->Flush();
	  
    ///IntvlRegulator(); // by M.S. 2013.6.16 for keeping constant interval. // miya comment
  	// add 2016/10/27 sekido start-----------------------------------------
  	//setenv("TZ","GMT",1);tzset();
    time_t pc_time;    time(&pc_time);
    while(pc_time < data_epoch + 1){ 
      Logsystem::error_logger()->Tstamp() << "E: Waiting for data_epoch" << data_epoch << 
	", since it is in future.\n";
      Logsystem::error_logger()->Flush();
      sleep(1);
      time(&pc_time);
    }// add 2016/10/27 sekido end-----------------------------------------
    raw_data = input_mdl->MappingData ( data_epoch );
    Logsystem::debug_logger()->Tstamp() << "data_epoch = " << data_epoch << "\n";
    Logsystem::debug_logger()->Flush();

    if( raw_data == 0){
      // miya comment start-------------------------------------------------------------
      ///time_t frm_epoch= input_mdl->Epoch(ipage);
      ///if( frm_epoch > data_epoch){
      ///cerr << "W Expected epoch(" << data_epoch << ") < Dev-Epoch(" << ipage << ")=" 
      ///     << frm_epoch << "\n";
      ///Logsystem::info_logger()->Tstamp() 
      ///  << "W Expected epoch(" << data_epoch << ") < Dev-Epoch(" << ipage << ")=" 
      ///  << frm_epoch << "\n";
      ///data_epoch ++; ipage++;
      ///continue;
      ///}
      ///Logsystem::error_logger()->Tstamp()
      ///<< "I " << func_id <<	 "MappingData("<< data_epoch << ") failed..\n";
      ///cerr << "I " << func_id << "MappingData(" << data_epoch << ") failed." << endl;
      // miya comment end-------------------------------------------------------------
      if( input_mdl->DevType() != InDev_Model::K5VSI ){ // add 'if' 2014/11/11 miya
	StopState();
	//	return -0;
	break;
      }
      // add 2016/9/29 miya start---------------------------------------------------
      if ( vlbi_frame->Type() != VLBI_Frame::VDIF_frm ){
	//zero_data_epoch=data_epoch+npage;
	//while (data_epoch!=zero_data_epoch){
	  vlbi_frame->Set_Epoch(data_epoch);
	  if(!Is_SingleOut){
	    for(int ith=0; ith < NFileout; ith++) { 
	      proto_mdl[ith]->pVLBI_Frame()->Set_Epoch(data_epoch); 
	    }
	  }
	  if(Is_SingleOut){ // Straight output from input 
	    nsent = proto_mdl[0]->TX1seczero( data_epoch, page_size);
	  }else{   // InputMode != OutputMode
	    for(int ith=0; ith < NFileout; ith++){
	      nsent = proto_mdl[ith]->TX1secSubzero( data_epoch, page_size, &inDAS);
	    }
	  }
	  //data_epoch++;
	//}
      }// add 2016/9/29 miya end---------------------------------------------------
    }else{ // add 'else' 2014/11/11 miya
      //     if(Logsystem::Test_Logsys(Logsystem::INFO))  {
      //       char dumbuf[256];
      //       struct tm tm1;
      //       gmtime_r ( &data_epoch, &tm1 );
      //       strftime ( dumbuf,256,"%Y/%j-%H:%M:%S",&tm1 );
      //       Logsystem::info_logger()->Tstamp() 
      // 	<< "I " << func_id << "Sending out data [" << dumbuf << "] at "
      // 	<< proto_mdl->Tx_rate() << " Mbps (net:"
      // 	<< proto_mdl->Tx_pld_rate()  << " Mbps)\n";
      //       Logsystem::info_logger()->Flush();
      //       cerr  << "I " << func_id << "Sending out data [" 
      // 	    << dumbuf << "] at "
      // 	    << proto_mdl->Tx_rate() << " Mbps (net:"
      // 	    << proto_mdl->Tx_pld_rate()  << " Mbps)" << endl;
      //     }
      vlbi_frame->Set_Epoch(data_epoch);
      if(!Is_SingleOut){ // add 2014/12/9 miya
	for(int ith=0; ith < NFileout; ith++) { // add 2014/12/9 miya
	  proto_mdl[ith]->pVLBI_Frame()->Set_Epoch(data_epoch); // add 2014/12/9 miya
	}
      }
      
      //bool Is_SingleOut = (outDAS.Speed() == inDAS.Speed()); //2014/12/9 comment miya
      // If single output, DAS-info is copied from input.
      if(Is_SingleOut){ // Straight output from input 
	    //	nsent = proto_mdl->TX1sec( data_epoch, pntr);
		nsent = proto_mdl[0]->TX1sec( data_epoch, raw_data, page_size);
      }else{   // InputMode != OutputMode
	   //	nsent = proto_mdl->TX1secSub( data_epoch, pntr, &inDAS);
		for(int ith=0; ith < NFileout; ith++){ // add 2014/12/9 miya
			nsent = proto_mdl[ith]->TX1secSub( data_epoch, raw_data, page_size, &inDAS);
		}
      }
      if ( nsent < 0 ) {
	Logsystem::error_logger()->Tstamp()
	  << "E " << func_id << "proto_mdl->TX1sec() failed, quitting.\n";
	break;
      }
      //     fprintf(stderr, "%4d Epoch = %s :",past_sec,time_code);
      //     fprintf(stderr,"Mode = %s (%.2lf Mbps): ",
      // 	    vlbi_frame->DAS_Inf()->Mode().c_str(), 0.000001*(8*nsent));
      //     fprintf(stderr,"Send rate = %.2lf [Mbps] ttl %.2lf MB\n",
      // 	    proto_mdl->TX_rate(), proto_mdl->Sent_MBytes());
      
      //      input_mdl->UnMapping ( data_epoch ); // Release the address mapping
      if( input_mdl->UnMapping ( data_epoch ) == InDev_Model::GEN_ERROR){
	cerr << "*******************************************************************\n";
	cerr << "E FileDumper[" << func_id 
	     << "]::Sending(): InDev Catch Up to Dumer-Output due to slow output."
	     << endl;
	cerr << "*******************************************************************\n";
	Logsystem::error_logger()->Tstamp() 
	  << "E FileDumper::Writing(): InDev Catch Up to Dumer-Output due to slow output.\n";
	StopState();
	continue;
      }else{
	Logsystem::info_logger()->Tstamp() 
	  << "I " << func_id << "UnMapping end.\n";
      }
    }// add miya 2014/11/11
    data_epoch ++;
    
    Logsystem::debug_logger()->Tstamp()
      << "D " << func_id << "Current Epoch=" << data_epoch << " +span(" 
      << tspan << ")End Epoch=" <<  first_epoch + tspan << "\n"; 
    Logsystem::debug_logger()->Flush();
    
    if ( tspan > 0 && data_epoch >= first_epoch + tspan ) {
      fprintf( stderr,
	       "I %s Stopping to write: Time Span(%d sec) has passed.\n",
	       func_id.c_str(), tspan );
      StopState();
      //	state= ENDING;
    }
    ///Logsystem::warning_logger()->Tstamp() 
  } // While loop
  
  Logsystem::info_logger()->Tstamp() << "I " << func_id << " end.\n";
  //    proto_mdl->Timer_Stop();
  return 0;
}

bool FileDumper::Ready(){
	
  if( proto_mdl[0]==0){
    cerr << "E FileDumper::Ready(): output protocol_model is not set." 
	 << endl;
    Logsystem::error_logger()->Tstamp()
      << "E FileDumper::Ready(): output protocol_model is not set.\n";
    return false;  
  }
  if(input_mdl ==0){
    cerr << "E FileDumper::Ready(): data input model is not set." << endl;
    Logsystem::error_logger()->Tstamp()
      << "E FileDumper::Ready(): data input model is not set.\n";
    return false;  
  }
  if( Thread::Status() == Thread::RUNNING){
      Logsystem::error_logger()->Tstamp()  
	  << "E FileDumper::Ready():FileDumper is already running..\n";
      return false;
  }
  
  Logsystem::debug_logger()->Tstamp()  
    << "D FileDumper::Ready():input_mdl->Ready() inprogress..";
  if(! input_mdl->Ready()){
    cerr << "E FileDumper::Ready(): input_mdl contents is not ready()";
    return false;
  }
  *Logsystem::debug_logger() << "input_mdl->Ready()Finished.\n";
  Logsystem::debug_logger()->Flush();
  
  if(input_mdl->Status() != Thread::RUNNING) input_mdl->start();

  if(vlbi_frame ==0){ // For output 
    cerr << "E FileDumper::Ready(): VLBI_frame is not set. " 
	 << "It must be set in Set_IO()."<< endl;
    Logsystem::error_logger()->Tstamp()
      << "E FileDumper::Ready(): VLBI_frame is not set" 
      << "It must be set in Set_IO().\n";
    return false;  
  }
  
//   /** If Nchs of input-output VLBI frame are the same, DAS-info is copied
//    * from input to Output.
//    * othewise original DAS-info in the proto_mdl is used. 
//    */
//   if(vlbi_frame->DAS_Inf().Nch() == input_mdl->Das_inf()->Nch()){
//     int nch = input_mdl->Das_inf()->Nch();
//     int nbit = input_mdl->Das_inf()->Qbit();
//     uint32_t  srate = input_mdl->Das_inf()->Srate();
//     vlbi_frame->Set_Sparam(nch, nbit,srate);
//   }

	for(int ith=0; ith < NFileout; ith++){ // add 2014/12/9 miya

	  if( ! proto_mdl[ith]->Tx_Ready() ){ //modify 2014/12/9 miya 0->ith
	    Logsystem::error_logger()->Tstamp()
	      << "E FileDumper::Ready(): proto_mdl->Tx_Ready() failed.\n"; //" << endl;
	  	Logsystem::error_logger()->Flush();
	    return false;
	  }
	}

  return true;
  
}

